$! Link procedure 
$! (c) Alexey Chupahin  15-MAR-2021
$! alexey@vaxman.de alexeychupahin@gmail.com
$!
$!
$ SET NOON
$WRITE SYS$OUTPUT " "
$WRITE SYS$OUTPUT "Create BZIP2 for OpenVMS  "
$WRITE SYS$OUTPUT "(c) Alexey Chupahin   CHAPG"
$WRITE SYS$OUTPUT " "
$! Checking architecture
$DECC = F$SEARCH("SYS$SYSTEM:DECC$COMPILER.EXE") .NES. ""
$    IF F$GETSYI("ARCH_TYPE").EQ.1 THEN CPU = "VAX"
$    IF F$GETSYI("ARCH_TYPE").EQ.2 THEN CPU = "Alpha"
$    IF F$GETSYI("ARCH_TYPE").EQ.3 THEN CPU = "I64"
$WRITE SYS$OUTPUT "Checking architecture 	...  ", CPU
$SHARED=0
$IF ( (CPU.EQS."Alpha").OR.(CPU.EQS."I64") )
$  THEN 
$	SHARED=64
$  ELSE
$	SHARED=32
$ENDIF
$IF (P1.EQS."STATIC") .OR. (P1.EQS."static") 
$ THEN 
$	SHARED=0
$	WRITE SYS$OUTPUT "Only static library will be configured"
$ENDIF
$!
$ SET DEF [.'CPU']
$ CURRENT = F$ENVIRONMENT (""DEFAULT"")
$ SET DEF [-]
$ CLAM=CURRENT
$ OPEN/WRITE OUT BZIP2$STARTUP.COM
$  WRITE OUT "$DEFINE BZ2LIB ",CLAM
$  WRITE OUT "$BZIP2:==$",CLAM,"BZIP2.EXE"
$  WRITE OUT "$BZIP2RECOVER:==$",CLAM,"BZIP2RECOVER.EXE"
$ CLOSE OUT
$!Creating OPT.OPT file containig external libraries (zlib,bzip2) for linker
$OPEN/WRITE OUT [.'CPU']BZIP2.OPT
$IF (SHARED.GT.0)  THEN  WRITE OUT "SYS$SHARE:BZIP2$SHR/SHARE"
$IF (SHARED.EQ.0)  THEN  WRITE OUT "BZ2LIB:BZIP2/LIB"
$CLOSE OUT
$WRITE SYS$OUTPUT "BZIP2.OPT has been created"
$IF (SHARED.EQ.64)
$ THEN
$	COPY SYS$INPUT [.'CPU']BZIP2$DEF.OPT
SYMBOL_VECTOR= (-
BZ2_bzCompressInit=PROCEDURE,-
BZ2_bzCompress=PROCEDURE,-
BZ2_bzCompressEnd=PROCEDURE,-
BZ2_bzDecompressInit=PROCEDURE,-
BZ2_bzDecompress=PROCEDURE,-
BZ2_bzDecompressEnd=PROCEDURE,-
BZ2_bzReadOpen=PROCEDURE,-
BZ2_bzReadClose=PROCEDURE,-
BZ2_bzReadGetUnused=PROCEDURE,-
BZ2_bzRead=PROCEDURE,-
BZ2_bzWriteOpen=PROCEDURE,-
BZ2_bzWrite=PROCEDURE,-
BZ2_bzWriteClose=PROCEDURE,-
BZ2_bzWriteClose64=PROCEDURE,-
BZ2_bzBuffToBuffCompress=PROCEDURE,-
BZ2_bzBuffToBuffDecompress=PROCEDURE,-
BZ2_bzlibVersion=PROCEDURE,-
BZ2_bzopen=PROCEDURE,-
BZ2_bzdopen=PROCEDURE,-
BZ2_bzread_vms=PROCEDURE,-
BZ2_bzwrite_vms=PROCEDURE,-
BZ2_bzflush=PROCEDURE,-
BZ2_bzclose=PROCEDURE,-
BZ2_bzerror=PROCEDURE-
)
$ ELSE
$	COPY SYS$INPUT [.'CPU']BZIP2$DEF.OPT
UNIVERSAL=BZ2_bzCompressInit
UNIVERSAL=BZ2_bzCompress
UNIVERSAL=BZ2_bzCompressEnd
UNIVERSAL=BZ2_bzDecompressInit
UNIVERSAL=BZ2_bzDecompress
UNIVERSAL=BZ2_bzDecompressEnd
UNIVERSAL=BZ2_bzReadOpen
UNIVERSAL=BZ2_bzReadClose
UNIVERSAL=BZ2_bzReadGetUnused
UNIVERSAL=BZ2_bzRead
UNIVERSAL=BZ2_bzWriteOpen
UNIVERSAL=BZ2_bzWrite
UNIVERSAL=BZ2_bzWriteClose
UNIVERSAL=BZ2_bzWriteClose64
UNIVERSAL=BZ2_bzBuffToBuffCompress
UNIVERSAL=BZ2_bzBuffToBuffDecompress
UNIVERSAL=BZ2_bzlibVersion
UNIVERSAL=BZ2_bzopen
UNIVERSAL=BZ2_bzdopen
UNIVERSAL=BZ2_bzread_vms
UNIVERSAL=BZ2_bzwrite_vms
UNIVERSAL=BZ2_bzflush
UNIVERSAL=BZ2_bzclose
UNIVERSAL=BZ2_bzerror
$ENDIF
$!
$ WRITE SYS$OUTPUT "Linking BZIP2 Share library"
$  LINK/SHARE=[.'CPU']BZIP2$SHR [.'CPU']BZLIB,[.'CPU']BZIP2/LIB,[.'CPU']BZIP2$DEF/OPT
$  COPY [.'CPU']BZIP2$SHR.EXE SYS$SHARE
$ WRITE SYS$OUTPUT "Linking BZIP2 executables
$ LINK/EXE=[.'CPU']BZIP2.EXE [.'CPU']BZIP2,BZIP2/OPT
$ LINK/EXE=[.'CPU']BZIP2RECOVER.EXE [.'CPU']BZIP2RECOVER,BZIP2/OPT
$!
$!
$ WRITE SYS$OUTPUT "" 
$ WRITE SYS$OUTPUT "***************************************************************************** "
$ WRITE SYS$OUTPUT "Link is completed."
$ WRITE SYS$OUTPUT "BZIP2$STARTUP.COM is created. "
$ WRITE SYS$OUTPUT "This file setups all logicals needed. It should be executed before using BZIP2 compressor or BZIP2 Library. "
$ WRITE SYS$OUTPUT "Use BZ2LIB:BZIP2.OPT to link you program"
$ WRITE SYS$OUTPUT "***************************************************************************** "
$!
